Subject: Re: Random crashes with 2.6.27-rc3 on PPC

From: Benjamin Herrenschmidt <[email-masked]>
Date: Mon, 25 Aug 2008 08:37:52 +1000

> Thanks for your random guess.
> The following workaround seems to fix the crashes on powerpc.
> However, this patch is clearly not what we want for other architectures,
> as they might need -fno-omit-frame-pointer to function properly.

Well, and -pg requires it, even on powerpc, so that won't work for
ftrace. Any chance you can try the workaround that segher proposed
though ?

http://penguinppc.de/~segher/0001-powerpc-Workaround-for-the-ftrace-problem.patch

His workaround only kicks in with CONFIG_FTRACE, that would have to be
fixed of course. Also, I suspect the bits that have -pg in a flag
"remove" section should have also "fno-omit-frame-pointer" in that
remove section too.

> I reproduced the random crashes of kernel and userspace applications
> (without the following patch) on a vanilla 2.6.26 and 2.6.27-rc{1-4}
> kernel. I did _not_ try a 2.6.25 kernel with -fno-omit-frame-pointer, so
> I don't know if it would also crash then.
> 
> I'm currently running more tests on a patched 2.6.27-rc4 kernel, but it
> didn't crash, yet. I already did 5 complete kernel tree compilations. It
> should have crashed by now, but it didn't :)

Thanks !

Ben.